#include "common.c"

int main(int ac,char **av)
{
    __u32 flowlabel = 0;
    int sock, len, err_num, itmp;
    socklen_t sin6_len = 0;
    uint16_t port = 0;
    struct in6_addr addr;
    struct sockaddr_in6 sin6, d_sin6;
    char *target, v6addr[128];

    sock = len = err_num = itmp = 0;
    if (ac != 4) {
	printf("usage: %s <flowlabel> <dst_host> <dst_port>\n",av[0]);
	return 0;
    }

    sscanf(av[1],"%x",&flowlabel);
    if (flowlabel == 0) {
	printf("flowlabel is null.\n");
	return -1;
    }
    target = av[2];
    sscanf(av[3],"%d",&itmp);
    if (itmp == 0) {
	printf("dst_port is null.\n");
	return -2;
    } else {
	port = (uint16_t)itmp;
    }

    if (getip6name(&addr, target, "dst_addr") < 0) return -3;
    sin6_len = sizeof(sin6);
    memset(&sin6, 0, sin6_len);
    sin6.sin6_family = AF_INET6;
    memcpy(&sin6.sin6_addr, &addr, 16);
    sin6.sin6_port = htons(port);
    sock = socket(PF_INET6, SOCK_STREAM, IPPROTO_TCP);
    if (sock < 0) {
	printf("cannot open INET6 socket.\n");
	return -4;
    }
    if (set_rxflow(sock) < 0) {
	printf("can't get flowlabel\n");
    }
    if (set_flowlabel(sock, &sin6, flowlabel) < 0) {
	printf("cannot use flowlabel.\n");
	close(sock);
	return -5;
    }
    if (connect(sock, (struct sockaddr *)&sin6, sin6_len) == -1) {
	perror("connect");
	err_num = -6;
	goto err;
    }

    len = send(sock, target, strlen(target), 0);
    if (len < 0) {
	perror("send");
	err_num = -7;
	goto err;
    }

    len = 0; memset(v6addr, 0, 128);
    len = recv(sock, v6addr, 128, 0);
    memcpy(&d_sin6, &sin6, sin6_len);
    d_sin6.sin6_flowinfo = 0;
    if (getlabel(sock, &d_sin6, &sin6_len) < 0) {
	perror("getpeername");
	return -21;
    }

    printf("dst_host flow has 0x%x.\n",ntohl(d_sin6.sin6_flowinfo));
    printf("message: %s\n", v6addr);
 err:
    release_flowlabel(sock, &sin6, flowlabel);
    close(sock);
    return err_num;
}
